Index: boost/exception/exception.hpp
===================================================================
--- boost/exception/exception.hpp	(revision 61342)
+++ boost/exception/exception.hpp	(working copy)
@@ -75,8 +75,8 @@
             void
             release()
                 {
-                if( px_ )
-                    px_->release();
+                if( px_ && px_->release() )
+					px_=0;
                 }
             };
         }
@@ -150,7 +150,7 @@
             virtual shared_ptr<error_info_base> get( type_info_ const & ) const = 0;
             virtual void set( shared_ptr<error_info_base> const &, type_info_ const & ) = 0;
             virtual void add_ref() const = 0;
-            virtual void release() const = 0;
+            virtual bool release() const = 0;
             virtual refcount_ptr<exception_detail::error_info_container> clone() const = 0;
 
             protected:
Index: boost/exception/info.hpp
===================================================================
--- boost/exception/info.hpp	(revision 61342)
+++ boost/exception/info.hpp	(working copy)
@@ -140,11 +140,16 @@
                 ++count_;
                 }
 
-            void
+            bool
             release() const
                 {
-                if( !--count_ )
+                if( --count_ )
+					return false;
+				else
+					{
                     delete this;
+					return true;
+					}
                 }
 
             refcount_ptr<error_info_container>
Index: libs/exception/test/refcount_ptr_test.cpp
===================================================================
--- libs/exception/test/refcount_ptr_test.cpp	(revision 61342)
+++ libs/exception/test/refcount_ptr_test.cpp	(working copy)
@@ -28,11 +28,16 @@
         ++count_;
         }
 
-    void
+    bool
     release()
         {
-        if( !--count_ )
+        if( --count_ )
+			return false;
+		else
+			{
             delete this;
+			return true;
+			}
         }
 
     private:
